
#include "xynth_.h"

#if defined(PLATFORM_PSPDEV)

#include <pspkernel.h>
#include <pspthreadman.h>
#include <pspmoduleinfo.h>

unsigned int usleep (unsigned long msec)
{
	unsigned long delay;
	delay = MIN(msec, 0xffffffffUL);
	sceKernelDelayThreadCB(delay);
	return 0;
}

unsigned int sleep (unsigned int sec)
{
	usleep(sec * 1000 * 1000);
	return 0;
}

#include <sys/time.h>
long s_gettimeofday (void)
{
	struct timeval tv;
	if (gettimeofday(&tv, NULL) < 0) {
		return -1;
	}
	return tv.tv_sec * 1000 + tv.tv_usec / 1000;
}

#else /* PLATFORM_PSPDEV */

#include <sys/time.h>
long s_gettimeofday (void)
{
	struct timeval tv;
	if (gettimeofday(&tv, NULL) < 0) {
		return -1;
	}
	return tv.tv_sec * 1000 + tv.tv_usec / 1000;
}

#endif
