/***************************************************************************
    begin                : Tue Oct 14 2003
    copyright            : (C) 2003 - 2005 by Alper Akcan
    email                : distchx@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SXYNTH_H
#define SXYNTH_H

#ifdef __cplusplus
	extern "C" {
#endif

typedef unsigned int s_thread_t;
typedef struct s_thread_sem_s s_thread_sem_t;
typedef struct s_thread_cond_s s_thread_cond_t;
typedef struct s_thread_mutex_s s_thread_mutex_t;

typedef struct s_font_ft_s s_font_ft_t;

typedef struct s_window_s s_window_t;
typedef struct s_handler_s s_handler_t;

typedef enum {
	SOC_DATA_NOTHING	  = 0x0,
	SOC_DATA_NEW		  = 0x1,
	SOC_DATA_HIDE		  = 0x2,
	SOC_DATA_SHOW		  = 0x3,
	SOC_DATA_CLOSE		  = 0x5,
	SOC_DATA_TITLE		  = 0x6,
	SOC_DATA_EVENT		  = 0x7,
	SOC_DATA_EXPOSE		  = 0x8,
	SOC_DATA_STREAM		  = 0x9,
	SOC_DATA_DISPLAY	  = 0xA,
	SOC_DATA_FORMDRAW	  = 0xB,
	SOC_DATA_CONFIGURE	  = 0xC,
	SOC_DATA_CONFIGURE_NOFORM = 0xD,
	SOC_DATA_DESKTOP	  = 0xE
} S_SOC_DATA;

typedef enum {
        WINDOW_NEW	  = 0x0001,
	WINDOW_COOR	  = 0x0002,
	WINDOW_DRAW	  = 0x0004,
	WINDOW_SHOW	  = 0x0008,
	WINDOW_TITLE      = 0x0010,
	WINDOW_RESIZEABLE = 0x0020,

	NO_FORM		  = 0x0040,
	WINDOW_MAIN	  = 0x0080,
	WINDOW_TEMP	  = 0x0100,
	WINDOW_CHILD	  = 0x0200,
	WINDOW_DESKTOP	  = 0x0400
} S_WINDOW;

typedef enum {
	SURFACE_REAL	   = 0x1,
	SURFACE_VIRTUAL    = 0x2,
	SURFACE_NEEDEXPOSE = 0x4,
	SURFACE_NEEDSTREAM = 0x8
} S_SURFACE_MODE;

typedef enum {
	MOUSE_CURSOR_WAIT,
	MOUSE_CURSOR_CROSS,
	MOUSE_CURSOR_IBEAM,
	MOUSE_CURSOR_SIZEV,
	MOUSE_CURSOR_SIZEH,
	MOUSE_CURSOR_SIZES,
	MOUSE_CURSOR_SIZEB,
	MOUSE_CURSOR_SIZEA,
	MOUSE_CURSOR_ARROW,
	MOUSE_CURSOR_POINT,
	MOUSE_CURSOR_SPLITV,
	MOUSE_CURSOR_SPLITH,
	MOUSE_CURSOR_FORBID,
	MOUSE_CURSOR_UPARROW,
	MOUSE_CURSOR_MAX
} S_MOUSE_CURSOR;

typedef enum {
	KEYCODE_NMLCKF	= 0x01,
	KEYCODE_CPLCKF	= 0x02,
	KEYCODE_LCTRLF	= 0x04,
	KEYCODE_RCTRLF	= 0x08,
	KEYCODE_LSHIFTF	= 0x10,
	KEYCODE_RSHIFTF	= 0x20,
	KEYCODE_LALTF	= 0x40,
	KEYCODE_RALTF	= 0x80,
	KEYCODE_SHIFTF	= (KEYCODE_LSHIFTF | KEYCODE_RSHIFTF),
	KEYCODE_CTRLF	= (KEYCODE_LCTRLF | KEYCODE_RCTRLF),
	KEYCODE_ALTF	= (KEYCODE_LALTF | KEYCODE_LALTF),
	KEYCODE_ALTGRF	= KEYCODE_RALTF
} S_KEYCODE_FLAG;

typedef enum {
/* Plain */
/*   0 */  S_KEYCODE_ESCAPE,
/*   1 */  S_KEYCODE_ONE,
/*   2 */  S_KEYCODE_TWO,
/*   3 */  S_KEYCODE_THREE,
/*   4 */  S_KEYCODE_FOUR,
/*   5 */  S_KEYCODE_FIVE,
/*   6 */  S_KEYCODE_SIX,
/*   7 */  S_KEYCODE_SEVEN,
/*   8 */  S_KEYCODE_EIGHT,
/*   9 */  S_KEYCODE_NINE,
/*  10 */  S_KEYCODE_ZERO,
/*  11 */  S_KEYCODE_MINUS,
/*  12 */  S_KEYCODE_EQUAL,
/*  13 */  S_KEYCODE_DELETE,
/*  14 */  S_KEYCODE_TAB,
/*  15 */  S_KEYCODE_q,
/*  16 */  S_KEYCODE_w,
/*  17 */  S_KEYCODE_e,
/*  18 */  S_KEYCODE_r,
/*  19 */  S_KEYCODE_t,
/*  20 */  S_KEYCODE_y,
/*  21 */  S_KEYCODE_u,
/*  22 */  S_KEYCODE_i,
/*  23 */  S_KEYCODE_o,
/*  24 */  S_KEYCODE_p,
/*  25 */  S_KEYCODE_BRACKETLEFT,
/*  26 */  S_KEYCODE_BRACKETRIGHT,
/*  27 */  S_KEYCODE_RETURN,
/*  28 */  S_KEYCODE_LEFTCONTROL,
/*  29 */  S_KEYCODE_a,
/*  30 */  S_KEYCODE_s,
/*  31 */  S_KEYCODE_d,
/*  32 */  S_KEYCODE_f,
/*  33 */  S_KEYCODE_g,
/*  34 */  S_KEYCODE_h,
/*  35 */  S_KEYCODE_j,
/*  36 */  S_KEYCODE_k,
/*  37 */  S_KEYCODE_l,
/*  38 */  S_KEYCODE_SEMICOLON,
/*  39 */  S_KEYCODE_APOSTROPHE,
/*  40 */  S_KEYCODE_GRAVE,
/*  41 */  S_KEYCODE_LEFTSHIFT,
/*  42 */  S_KEYCODE_BACKSLASH,
/*  43 */  S_KEYCODE_z,
/*  44 */  S_KEYCODE_x,
/*  45 */  S_KEYCODE_c,
/*  46 */  S_KEYCODE_v,
/*  47 */  S_KEYCODE_b,
/*  48 */  S_KEYCODE_n,
/*  49 */  S_KEYCODE_m,
/*  50 */  S_KEYCODE_COMMA,
/*  51 */  S_KEYCODE_PERIOD,
/*  52 */  S_KEYCODE_SLASH,
/*  53 */  S_KEYCODE_RIGHTSHIFT,
/*  54 */  S_KEYCODE_KP_MULTIPLY,
/*  55 */  S_KEYCODE_ALT,
/*  56 */  S_KEYCODE_SPACE,
/*  57 */  S_KEYCODE_CAPS_LOCK,
/*  58 */  S_KEYCODE_F1,
/*  59 */  S_KEYCODE_F2,
/*  60 */  S_KEYCODE_F3,
/*  61 */  S_KEYCODE_F4,
/*  62 */  S_KEYCODE_F5,
/*  63 */  S_KEYCODE_F6,
/*  64 */  S_KEYCODE_F7,
/*  65 */  S_KEYCODE_F8,
/*  66 */  S_KEYCODE_F9,
/*  67 */  S_KEYCODE_F10,
/*  68 */  S_KEYCODE_NUM_LOCK,
/*  69 */  S_KEYCODE_SCROLL_LOCK,
/*  70 */  S_KEYCODE_KP_7,
/*  71 */  S_KEYCODE_KP_8,
/*  72 */  S_KEYCODE_KP_9,
/*  73 */  S_KEYCODE_KP_SUBTRACT,
/*  74 */  S_KEYCODE_KP_4,
/*  75 */  S_KEYCODE_KP_5,
/*  76 */  S_KEYCODE_KP_6,
/*  77 */  S_KEYCODE_KP_ADD,
/*  78 */  S_KEYCODE_KP_1,
/*  79 */  S_KEYCODE_KP_2,
/*  80 */  S_KEYCODE_KP_3,
/*  81 */  S_KEYCODE_KP_0,
/*  82 */  S_KEYCODE_KP_PERIOD,
/*  83 */  S_KEYCODE_LAST_CONSOLE,
/*  84 */  S_KEYCODE_LESS,
/*  85 */  S_KEYCODE_F11,
/*  86 */  S_KEYCODE_F12,
/*  87 */  S_KEYCODE_KP_ENTER,
/*  88 */  S_KEYCODE_RIGHTCONTROL,
/*  89 */  S_KEYCODE_KP_DIVIDE,
/*  90 */  S_KEYCODE_VOIDSYMBOL,
/*  91 */  S_KEYCODE_ALTGR,
/*  92 */  S_KEYCODE_BREAK,
/*  93 */  S_KEYCODE_HOME,
/*  94 */  S_KEYCODE_UP,
/*  95 */  S_KEYCODE_PAGEUP,
/*  96 */  S_KEYCODE_LEFT,
/*  97 */  S_KEYCODE_RIGHT,
/*  98 */  S_KEYCODE_END,
/*  99 */  S_KEYCODE_DOWN,
/* 100 */  S_KEYCODE_PAGEDOWN,
/* 101 */  S_KEYCODE_INSERT,
/* 102 */  S_KEYCODE_REMOVE,
/* 103 */  S_KEYCODE_PAUSE,
/* Shift */
/* 104 */  S_KEYCODE_EXCLAM,
/* 105 */  S_KEYCODE_AT,
/* 106 */  S_KEYCODE_NUMBERSIGN,
/* 107 */  S_KEYCODE_DOLLAR,
/* 108 */  S_KEYCODE_PERCENT,
/* 109 */  S_KEYCODE_ASCIICIRCUM,
/* 110 */  S_KEYCODE_AMPERSAND,
/* 111 */  S_KEYCODE_ASTERISK,
/* 112 */  S_KEYCODE_PARENLEFT,
/* 113 */  S_KEYCODE_PARENRIGHT,
/* 114 */  S_KEYCODE_UNDERSCORE,
/* 115 */  S_KEYCODE_PLUS,
/* 116 */  S_KEYCODE_Q,
/* 117 */  S_KEYCODE_W,
/* 118 */  S_KEYCODE_E,
/* 119 */  S_KEYCODE_R,
/* 120 */  S_KEYCODE_T,
/* 121 */  S_KEYCODE_Y,
/* 122 */  S_KEYCODE_U,
/* 123 */  S_KEYCODE_I,
/* 124 */  S_KEYCODE_O,
/* 125 */  S_KEYCODE_P,
/* 126 */  S_KEYCODE_BRACELEFT,
/* 127 */  S_KEYCODE_BRACERIGHT,
/* 128 */  S_KEYCODE_A,
/* 129 */  S_KEYCODE_S,
/* 130 */  S_KEYCODE_D,
/* 131 */  S_KEYCODE_F,
/* 132 */  S_KEYCODE_G,
/* 133 */  S_KEYCODE_H,
/* 134 */  S_KEYCODE_J,
/* 135 */  S_KEYCODE_K,
/* 136 */  S_KEYCODE_L,
/* 137 */  S_KEYCODE_COLON,
/* 138 */  S_KEYCODE_QUOTEDBL,
/* 139 */  S_KEYCODE_ASCIITILDE,
/* 140 */  S_KEYCODE_BAR,
/* 141 */  S_KEYCODE_Z,
/* 142 */  S_KEYCODE_X,
/* 143 */  S_KEYCODE_C,
/* 144 */  S_KEYCODE_V,
/* 145 */  S_KEYCODE_B,
/* 146 */  S_KEYCODE_N,
/* 147 */  S_KEYCODE_M,
/* 149 */  S_KEYCODE_GREATER,
/* 150 */  S_KEYCODE_QUESTION,
/* 151 */  S_KEYCODE_F13,
/* 152 */  S_KEYCODE_F14,
/* 153 */  S_KEYCODE_F15,
/* 154 */  S_KEYCODE_F16,
/* 155 */  S_KEYCODE_F17,
/* 156 */  S_KEYCODE_F18,
/* 157 */  S_KEYCODE_F19,
/* 158 */  S_KEYCODE_F20,
/* 159 */  S_KEYCODE_F21,
/* 160 */  S_KEYCODE_F22,
/* 161 */  S_KEYCODE_SHOW_MEMORY,
/* 162 */  S_KEYCODE_F23,
/* 163 */  S_KEYCODE_F24,
/* 164 */  S_KEYCODE_SCROLL_BACKWARD,
/* 165 */  S_KEYCODE_SCROLL_FORWARD,
/* ALTGR */
/* 166 */  S_KEYCODE_CURRENCY,
/* 167 */  S_KEYCODE_CENT,
/* 168 */  S_KEYCODE_HEX_C,
/* 169 */  S_KEYCODE_HEX_A,
/* 170 */  S_KEYCODE_SHOW_REGISTERS,
/* 171 */  S_KEYCODE_HEX_7,
/* 172 */  S_KEYCODE_HEX_8,
/* 173 */  S_KEYCODE_HEX_9,
/* 174 */  S_KEYCODE_HEX_D,
/* 175 */  S_KEYCODE_HEX_4,
/* 176 */  S_KEYCODE_HEX_5,
/* 177 */  S_KEYCODE_HEX_6,
/* 178 */  S_KEYCODE_HEX_E,
/* 179 */  S_KEYCODE_HEX_1,
/* 180 */  S_KEYCODE_HEX_2,
/* 181 */  S_KEYCODE_HEX_3,
/* 182 */  S_KEYCODE_HEX_0,
/* 183 */  S_KEYCODE_HEX_F,
/* 184 */  S_KEYCODE_HEX_B,
/* 185 */  S_KEYCODE_NOCODE,
/* 186 */  S_KEYCODE_CODES
} S_KEYCODE_CODE;

typedef enum {
	MOUSE_RIGHTBUTTON	= 0x001,
	MOUSE_MIDDLEBUTTON	= 0x002,
	MOUSE_LEFTBUTTON	= 0x004,
	MOUSE_FOURTHBUTTON	= 0x008,
	MOUSE_FIFTHBUTTON	= 0x010,
	MOUSE_SIXTHBUTTON	= 0x020,
	MOUSE_RESETBUTTON	= 0x040,
	MOUSE_WHEELXBUTTON_U	= 0x080,
	MOUSE_WHEELXBUTTON_D	= 0x100,
	MOUSE_WHEELYBUTTON_U	= 0x200,
	MOUSE_WHEELYBUTTON_D	= 0x400,
	MOUSE_NONEBUTTON	= 0x800
} S_MOUSECODE_CODE;

typedef enum {
        QUIT_EVENT	= 0x00001,
	KEYBD_EVENT	= 0x00002,
	KEYBD_RELEASED	= 0x00004,
	KEYBD_PRESSED	= 0x00008,
	MOUSE_EVENT	= 0x00010,
	MOUSE_OVER	= 0x00020,
	MOUSE_RELEASED	= 0x00040,
	MOUSE_PRESSED	= 0x00080,
	MOUSE_CLICKED	= 0x00100,
	MOUSE_HINT	= 0x00200,
	MOUSE_HINT2	= 0x00400,
        EXPOSE_EVENT	= 0x00800,
        EXPOSE_CHNGX	= 0x01000,
        EXPOSE_CHNGY	= 0x02000,
        EXPOSE_CHNGW	= 0x04000,
        EXPOSE_CHNGH	= 0X08000,
        EXPOSE_CHNGF	= 0X10000,
        DESKTOP_EVENT   = 0x20000,
        TIMER_EVENT	= 0x40000,
	EVENT_MASK	= (QUIT_EVENT | EXPOSE_EVENT | KEYBD_EVENT | MOUSE_EVENT | DESKTOP_EVENT | TIMER_EVENT)
} S_EVENT;

typedef enum {
	MOUSE_HANDLER	= 0x1,
	KEYBD_HANDLER	= 0x2
} S_HANDLER;

typedef struct s_list_node_s {
        void *next;
        void *element;
} s_list_node_t;

typedef struct s_list_s {
        int nb_elt;
        s_list_node_t *node;
} s_list_t;

typedef struct s_rect_s {
	int x;
	int y;
	int w;
	int h;
} s_rect_t;

typedef struct s_config_var_s {
	char *name;
	char *value;
} s_config_var_t;

typedef struct s_config_cat_s {
	char *name;
	s_list_t *variable;
} s_config_cat_t;

typedef struct s_config_s {
	s_list_t *category;
} s_config_t;

typedef struct s_image_s {
	int x;
	int y;
	int w;
	int h;
	char *buf;
	unsigned char *mat;
	s_rect_t handler;
	unsigned int delay;
	unsigned int *rgba;
	s_list_t *layers;
} s_image_t;

typedef struct s_font_s {
	int yMin;
	int yMax;
	char *str;
	int size;
	s_image_t *img;
	s_font_ft_t *ft;
} s_font_t;

typedef struct s_pollfd_s {
	int fd;
	int (*pf_in) (s_window_t *, int);
	int (*pf_err) (s_window_t *, int);
	int (*pf_close) (s_window_t *, int);
} s_pollfd_t;

typedef struct s_pollfds_s {
	s_list_t *list;
	s_thread_mutex_t *mut;
} s_pollfds_t;

typedef struct s_mouse_s {
	int x;
	int y;
	S_MOUSECODE_CODE b;
	int clicks;		  /* click count		 */
	S_MOUSECODE_CODE buttons; /* buttons bitwise ORed  */
	long time;		  /* event time	 	 */
	int px;			  /* prev. pressed coor.   */
	int py;
	int pb;			  /* prev. pressed button  */
	S_MOUSECODE_CODE pbuttons;/* prev. pressed buttons */
	long ctime;		  /* prev. clicked time	 */
	S_MOUSE_CURSOR cursor;
} s_mouse_t;

typedef struct s_keybd_s {
	int ascii;
	int button;
	int keycode;
	int scancode;
	int state[S_KEYCODE_CODES];
	S_KEYCODE_FLAG flag;
} s_keybd_t;

typedef struct s_expose_s {
	int change;
	s_rect_t rect;
} s_expose_t;

typedef struct s_stream_s {
	int bitspp;
	s_rect_t rect;
	int blen;
	char *buf;
} s_stream_t;

typedef struct s_desktop_client_s {
	int id;
	int pri;
	int title_l;
	char *title;
} s_desktop_client_t;

typedef struct s_dekstop_s {
	s_list_t *clients;
} s_desktop_t;

typedef struct s_timer_s {
	long timeval;
	long interval;
	void (*cb) (s_window_t *, struct s_timer_s *);
	void *user_data;
} s_timer_t;

typedef struct s_timers_s {
	s_list_t *timers;
	s_thread_mutex_t *mut;
} s_timers_t;

typedef struct s_event_s {
	S_EVENT type;
	s_mouse_t *mouse;
	s_keybd_t *keybd;
	s_expose_t *expose;
	s_desktop_t *desktop;
	s_timer_t *timer;
} s_event_t;

typedef struct s_eventq {
	s_thread_t tid;
	s_list_t *queue;
        s_thread_cond_t *cond;
	s_thread_mutex_t *mut;
} s_eventq_t;

typedef struct s_handler_keybd_s {
	int flag;
	int button;
	void (*p) (s_window_t *, s_event_t *, s_handler_t *);
	void (*r) (s_window_t *, s_event_t *, s_handler_t *);
} s_handler_keybd_t;

typedef struct s_handler_mouse_s {
	int x;
	int y;
	int w;
	int h;
	int button;
	void (*p) (s_window_t *, s_event_t *, s_handler_t *);	/* button pressed   		                                */
	void (*r) (s_window_t *, s_event_t *, s_handler_t *);	/* button released,          			                */
	void (*c) (s_window_t *, s_event_t *, s_handler_t *);	/* button clicked,                     			        */
	void (*o) (s_window_t *, s_event_t *, s_handler_t *);	/* on over 				                        */
	void (*ho) (s_window_t *, s_event_t *, s_handler_t *);	/* on over && hint,                                             */
								/* on over, but mouse button is still pressed		        */
	void (*hr) (s_window_t *, s_event_t *, s_handler_t *);	/* button realesed && hint	                                */
								/* mouse button released, but the prev. press was not on us	*/
	void (*oh) (s_window_t *, s_event_t *, s_handler_t *);	/* button over && hint2		                                */
								/* not on over, but was on over                                 */
	void (*hoh) (s_window_t *, s_event_t *, s_handler_t *); /* button over && hint && hint2	                                */
								/* not on over, but was on over. and button is still pressed    */
	void (*rh) (s_window_t *, s_event_t *, s_handler_t *);	/* button realesed && hint2	                                */
								/* mouse button released outside, but the prev. press was on us */
			                                        /* wheel buttons has no realesed event                          */
	S_EVENT hstate;
} s_handler_mouse_t;
                                     
struct s_handler_s {
	S_HANDLER type;
	s_handler_mouse_t mouse;
	s_handler_keybd_t keybd;
	void *user_data;
};

typedef struct s_handlers_s {
	s_list_t *list;
	s_thread_mutex_t *mut;
} s_handlers_t;

typedef struct s_childs_s {
	s_list_t *list;
	s_thread_mutex_t *mut;
} s_childs_t;

typedef struct s_surface_s {
       	S_SURFACE_MODE mode;

	int bytesperpixel;		/* We need to get them from server, to be able to draw right	*/
	int bitsperpixel;		/* thing on linear buffer.					*/

	int colors;			/* These are for future compability				*/
	int blueoffset;
	int greenoffset;
	int redoffset;
	int bluelength;
	int greenlength;
	int redlength;

	int width;			/* These are the real sizes of our buffer			*/
	int height;

        char *vbuf;			/* The buffer that holds clients window.			*/

	s_rect_t buf;			/* This is our bufs virtual part				*/
	s_rect_t win;

	char *linear_buf;		/* mapped shared buffer						*/
	int linear_buf_width;		/* See s_client_surface_linear()				*/
	int linear_buf_pitch;
	int linear_buf_height;
	unsigned int linear_mem_base;	/* We have to get the properties and the address of linear	*/
	unsigned int linear_mem_size;	/* buffer to be able to draw on it.				*/

        int *id;			/* ugly hack, window->surface->id = &(window->client->id);	*/
	int shm_mid;			/* shared screen matrix						*/
	unsigned char *matrix;

        int shm_sid;			/* shared linear buffer						*/
	int need_expose;
        s_window_t *window;		/* ugly hack, window->surface->window = window;			*/
} s_surface_t;

typedef struct s_object_s {
	s_list_t *childs;		/* object`s childs	*/
	s_thread_mutex_t *mut;		/* object`s root mutex	*/
	s_surface_t *surface;		/* object`s surface	*/
	struct s_object_s *parent;	/* object`s parent	*/
} s_object_t;

typedef struct s_client_s {
	int id;
	int pri;
	char *title;

	char *driver;
	char *device;

	int resizeable;
	int alwaysontop;

	void (*atevent) (s_window_t *, s_event_t *);
	void (*atexit) (s_window_t *);

	void *user_data;
} s_client_t;

struct s_window_s {
	int running;
	int soc;
	int wsoc;
	S_WINDOW type;

	s_client_t *client;
	s_surface_t *surface;

	s_eventq_t *eventq;
	s_timers_t *timers;
	s_childs_t *childs;
	s_pollfds_t *pollfds;
	s_handlers_t *handlers;

	s_thread_t tid;
	s_window_t *parent;

	s_event_t *event;
	s_thread_mutex_t *socket_mutex;
};

typedef struct s_single_app_s {
	int (*fonk) (int argc, char *argv[]);
	int argc;
	char *argv[10];
} s_single_app_t;

/* alloc.c */
void * s_malloc (unsigned int size);
void * s_calloc (unsigned int nmemb, unsigned int size);
void * s_realloc (void *ptr, unsigned int size);
void s_free (void *ptr);

/* child.c */
int s_child_add (s_window_t *window, s_window_t *child);
int s_child_del (s_window_t *window, s_window_t *child);
int s_childs_init (s_window_t *window);
int s_childs_uninit (s_window_t *window);

/* client.c */
int s_client_init (s_window_t **window);
void s_client_uninit (s_window_t *window);
void s_client_exit (s_window_t *window);
void s_client_quit (s_window_t *window);
int s_client_wakeup (s_window_t *window);
int s_client_child_find (s_window_t *parent, s_window_t *window, s_event_t *event);
void * s_client_loop_event (void *arg);
void * s_client_loop (void *arg);
void * s_client_main (void *arg);
void s_client_atevent (s_window_t *window, void (*f) (s_window_t *, s_event_t *));
void s_client_atexit (s_window_t *window, void (*f) (s_window_t *));

/* config.c */
char * s_config_strip (char *buf);
int s_config_parse (s_config_t *cfg, char *name);
int s_config_init (s_config_t **cfg);
int s_config_category_init (s_config_cat_t **cat, char *name);
int s_config_variable_init (s_config_var_t **var, char *name, char *value);
int s_config_variable_uninit (s_config_var_t *var);
int s_config_category_uninit (s_config_cat_t *cat);
int s_config_uninit (s_config_t *cfg);

/* debugf.c */
void s_debug_debugf (unsigned short flags, char *file, int line, char *func, char *fmt, ...);

/* driver.c */
void bpp_setpixel (s_surface_t *surface, int x, int y, int c);
void bpp_setpixel_o (s_surface_t *surface, int id, int x, int y, int c);
int bpp_getpixel (s_surface_t *surface, int x, int y);
int bpp_getpixel_o (s_surface_t *surface, int id,  int x, int y);
void bpp_hline (s_surface_t *surface, int x1, int y, int x2, int c);
void bpp_hline_o (s_surface_t *surface, int id,  int x1, int y, int x2, int c);
void bpp_vline (s_surface_t *surface, int x, int y1, int y2, int c);
void bpp_vline_o (s_surface_t *surface, int id,  int x, int y1, int y2, int c);
void bpp_fillbox (s_surface_t *surface, int x, int y, int w, int h, int c);
void bpp_fillbox_o (s_surface_t *surface, int id,  int x, int y, int w, int h, int c);
void bpp_putbox (s_surface_t *surface, int x, int y, int w, int h, char *sp, int bw);
void bpp_putbox_mask (s_surface_t *surface, int x, int y, int w, int h, char *sp, unsigned char *sm, int bw);
void bpp_getbox (s_surface_t *surface, int x, int y, int w, int h, char *dp);
void bpp_putbox_o (s_surface_t *surface, int id,  int x, int y, int w, int h, char *sp, int bw);
void bpp_putbox_mask_o (s_surface_t *surface, int id,  int x, int y, int w, int h, char *sp, unsigned char *sm, int bw);
void bpp_getbox_o (s_surface_t *surface, int id,  int x, int y, int w, int h, char *dp);

/* event.c */
int s_event_mouse_state (s_window_t *window, s_event_t *event, s_handler_mouse_t *mouse, int over);
void s_event_parse_mouse (s_window_t *window, s_event_t *event);
int s_event_parse_keybd (s_window_t *window, s_event_t *event);
int s_event_parse_expos (s_window_t *window, s_event_t *event);
int s_event_parse_timer (s_window_t *window, s_event_t *event);
int s_event_changed (s_window_t *window);
int s_event_init (s_event_t **event);
int s_event_uninit (s_event_t *event);

/* eventq.c */
int s_eventq_init (s_window_t *window);
int s_eventq_uninit (s_window_t *window);
int s_eventq_add (s_window_t *window, s_event_t *event);
int s_eventq_get (s_window_t *window, s_event_t **event);
int s_eventq_wait (s_window_t *window, s_event_t **event);

/* font.c */
int s_font_init (s_font_t **font, char *name);
int s_font_uninit (s_font_t *font);
int s_font_set_size (s_font_t *font, int size);
int s_font_set_str (s_font_t *font, char *str);
int s_font_get_glyph (s_font_t *font);

/* gettime.c */
long s_gettimeofday (void);

/* grlib.c */
int s_grlib_stream (s_surface_t *surface, s_rect_t *coor);
int s_rgbcolor (s_surface_t *surface, int r, int g, int b);
void s_colorrgb (s_surface_t *surface, int c, int *r, int *g, int *b);
void s_setpixel (s_surface_t *surface, int x, int y, int c);
void s_setpixelrgb (s_surface_t *surface, int x, int y, int r, int g, int b);
void s_setpixelrgba (s_surface_t *surface, int x, int y, int r, int g, int b, int a);
int s_getpixel (s_surface_t *surface, int x, int y);
void s_getpixelrgb (s_surface_t *surface, int x, int y, int *r, int *g, int *b);
void s_hline (s_surface_t *surface, int x1, int y, int x2, int c);
void s_vline (s_surface_t *surface, int x, int y1, int y2, int c);
void s_fillbox (s_surface_t *surface, int x, int y, int w, int h, int c);
void s_putbox (s_surface_t *surface, int x, int y, int w, int h, char *sp);
void s_putboxmask (s_surface_t *surface, int x, int y, int w, int h, char *sp, unsigned char *sm);
void s_getbox (s_surface_t *surface, int x, int y, int w, int h, char *dp);
void s_putboxpart (s_surface_t *surface, int x, int y, int w, int h, int bw, int bh, char *sp, int xo, int yo);
void s_putboxpartmask (s_surface_t *surface, int x, int y, int w, int h, int bw, int bh, char *sp, unsigned char *sm, int xo, int yo);
void s_copybox (s_surface_t *surface, int x1, int y1, int w, int h, int x2, int y2);
void s_getsurfacevirtual (s_surface_t *s, int w, int h, int bitspp, char *vbuf);
int s_copybuffer (char *sb, int sbitspp, char **db, int dbitspp, int w, int h);
void s_scalebox (s_surface_t *surface, int w1, int h1, void *_dp1, int w2, int h2, void *_dp2);

/* handler.c */
int s_handler_init (s_handler_t **handler);
int s_handler_uninit (s_handler_t *handler);
int s_handler_add (s_window_t *window, s_handler_t *handler);
int s_handler_del (s_window_t *window, s_handler_t *handler);
int s_handlers_init (s_window_t *window);
int s_handlers_uninit (s_window_t *window);

/* image.c */
int s_image_hex2int (char *str);
int s_image_get_mat (s_image_t *img);
int s_image_get_buf (s_surface_t *surface, s_image_t *img);
void s_image_get_handler (s_image_t *img);
int s_image_init (s_image_t **img);
void s_image_free_buf (s_image_t *img);
void s_image_free_mat (s_image_t *img);
void s_image_free_rgba (s_image_t *img);
int s_image_uninit (s_image_t *img);
int s_image_layer_init (s_image_t **lyr);
int s_image_layer_uninit (s_image_t *lyr);
int s_image_layers_init (s_image_t *img);
int s_image_layers_uninit (s_image_t *img);
int s_image_img (char *file, s_image_t *img);

/* image_gif.c */
int s_image_gif_is (char *file);
int s_image_gif (char *file, s_image_t *img);
/* image_png.c */
int s_image_png_is (char *file);
int s_image_png (char *file, s_image_t *img);

/* image_xpm.c */
int s_image_xpm_is (char *file);
int s_image_xpm (char *file, s_image_t *img);

/* list.c */
int s_list_init (s_list_t *li);
int s_list_eol (s_list_t *li, int i);
void * s_list_get (s_list_t *li, int pos);
int s_list_remove (s_list_t *li, int pos);
int s_list_add (s_list_t *li, void *el, int pos);
void * s_list_find (s_list_t *list, void *node, int (*cmp_func) (void *, void *));
int s_list_get_pos (s_list_t *list, void *node);

/* object.c */
int s_object_update_to_surface (s_object_t *object, s_surface_t *surface, s_rect_t *coor);
int s_object_update (s_object_t *object, s_rect_t *coor);
int s_object_move (s_object_t *object, int x, int y, int w, int h);
int s_object_hide (s_object_t *object);
int s_object_show (s_object_t *object);
int s_object_init (s_window_t *window, s_object_t **object, int w, int h, s_object_t *parent);
int s_object_uninit (s_object_t *object);

/* pollfd.c */
int s_pollfd_init (s_pollfd_t **pfd);
int s_pollfd_uninit (s_pollfd_t *pfd);
int s_pollfd_find_cmp_f (void *p1, void *p2);
s_pollfd_t * s_pollfd_find (s_window_t *window, int fd);
int s_pollfd_add (s_window_t *window, s_pollfd_t *pfd);
int s_pollfd_del (s_window_t *window, s_pollfd_t *pfd);
int s_pollfds_init (s_window_t *window);
int s_pollfds_uninit (s_window_t *window);

/* rect.c */
int s_rect_intersect (s_rect_t *r1, s_rect_t *r2, s_rect_t *r);
int s_rect_clip_virtual (s_surface_t *surface, int x, int y, int w, int h, s_rect_t *coor);
int s_rect_clip_real (s_surface_t *surface, int x, int y, int w, int h, s_rect_t *coor);
int s_rect_difference_add (s_list_t *list, int x, int y, int w, int h);
int s_rect_difference (s_rect_t *r1, s_rect_t *r0, s_list_t *list);

/* socket.c */
int s_socket_request_new (s_window_t *window, int soc);
int s_socket_request_title (s_window_t *window, int soc);
int s_socket_request_display (s_window_t *window, int soc);
int s_socket_request_configure (s_window_t *window, int soc, S_WINDOW form);
int s_socket_request_desktop (s_window_t *window, int soc, int id);
int s_socket_request (s_window_t *window, S_SOC_DATA req, ...);
int s_socket_listen_event (s_window_t *window, int soc);
int s_socket_listen_expose (s_window_t *window, int soc);
int s_socket_listen_desktop (s_window_t *window, int soc);
int s_socket_listen_parse (s_window_t *window, int soc);
int s_socket_listen_wait (s_window_t *window, int timeout);
int s_socket_uninit (s_window_t *window, int s);
int s_socket_in_f (s_window_t *window, int s);
int s_socket_ierr_f (s_window_t *window, int s);
int s_socket_inw_f (s_window_t *window, int s);
int s_socket_ierrw_f (s_window_t *window, int s);
int s_socket_closew_f (s_window_t *window, int s);	
int s_socket_init_uds (s_window_t *window);
int s_socket_init_tcp (s_window_t *window);
int s_socket_init_wakeup (s_window_t *window);
int s_socket_init (s_window_t *window);

/* surface.c */
int s_surface_init (s_window_t *window);
void s_surface_create (s_window_t *window);
void s_surface_shm_attach (s_window_t *window);
void s_surface_linear (s_window_t *window);
void s_surface_uninit (s_window_t *window);
void s_surface_changed (s_window_t *window, s_rect_t *changed);

/* thread.c */
int s_thread_sem_create (s_thread_sem_t *sem, int initial);
int s_thread_sem_destroy (s_thread_sem_t *sem);
int s_thread_sem_wait (s_thread_sem_t *sem);
int s_thread_sem_wait_timeout (s_thread_sem_t *sem, int msec);
int s_thread_sem_post (s_thread_sem_t *sem);
int s_thread_mutex_init (s_thread_mutex_t **mut);
int s_thread_mutex_destroy (s_thread_mutex_t *mut);
int s_thread_mutex_lock (s_thread_mutex_t *mut);
int s_thread_mutex_trylock (s_thread_mutex_t *mut);
int s_thread_mutex_unlock (s_thread_mutex_t *mut);
int s_thread_cond_init (s_thread_cond_t **cond);
int s_thread_cond_destroy (s_thread_cond_t *cond);
int s_thread_cond_signal (s_thread_cond_t *cond);
int s_thread_cond_broadcast (s_thread_cond_t *cond);
int s_thread_cond_wait (s_thread_cond_t *cond, s_thread_mutex_t *mut);
int s_thread_cond_timedwait (s_thread_cond_t *cond, s_thread_mutex_t *mut, int msec);
void * s_thread_run (void *farg);
s_thread_t s_thread_create (void * (*f) (void *), void *farg);
int s_thread_cancel (s_thread_t tid);
int s_thread_join (s_thread_t tid, void **ret);
s_thread_t s_thread_self (void);
void s_thread_exit (void *ret);

/* timer.c */
int s_timer_init (s_timer_t **timer);
int s_timer_timeval (s_window_t *window, s_timer_t *timer, int timeval);
int s_timer_uninit (s_timer_t *timer);
int s_timer_del (s_window_t *window, s_timer_t *timer);
int s_timer_add (s_window_t *window, s_timer_t *timer);
int s_timers_init (s_window_t *window);
int s_timers_uninit (s_window_t *window);

/* window.c */
void s_window_set_title (s_window_t *window, char *fmt, ...);
void s_window_form_draw (s_window_t *window);
void s_window_hide (s_window_t *window);
void s_window_show (s_window_t *window);
void s_window_set_coor (s_window_t *window, int form, int x, int y, int w, int h);
void s_window_set_resizeable (s_window_t *window, int resizeable);
void s_window_set_alwaysontop (s_window_t *window, int alwaysontop);
int s_window_new (s_window_t *window, S_WINDOW type, s_window_t *parent);

#ifdef __cplusplus
	}
#endif

#endif
